
/* Python wrapper functions auto-generated by pidl */
#define PY_SSIZE_T_CLEAN 1 /* We use Py_ssize_t for PyArg_ParseTupleAndKeywords */
#include <Python.h>
#include "python/py3compat.h"
#include "includes.h"
#include <pytalloc.h>
#include "librpc/rpc/pyrpc.h"
#include "librpc/rpc/pyrpc_util.h"
#include "bin/default/librpc/gen_ndr/ndr_smb2_lease_struct.h"
#include "bin/default/librpc/gen_ndr/ndr_smb2_lease_struct_c.h"

/*
 * These functions are here to ensure they can be optimized out by
 * the compiler based on the constant input values
 */

static inline unsigned long long ndr_sizeof2uintmax(size_t var_size)
{
	switch (var_size) {
	case 8:
		return UINT64_MAX;
	case 4:
		return UINT32_MAX;
	case 2:
		return UINT16_MAX;
	case 1:
		return UINT8_MAX;
	}

	return 0;
}

static inline long long ndr_sizeof2intmax(size_t var_size)
{
	switch (var_size) {
	case 8:
		return INT64_MAX;
	case 4:
		return INT32_MAX;
	case 2:
		return INT16_MAX;
	case 1:
		return INT8_MAX;
	}

	return 0;
}

static inline PyObject *ndr_PyLong_FromLongLong(long long v)
{
	if (v > LONG_MAX || v < LONG_MIN) {
		return PyLong_FromLongLong(v);
	} else {
		return PyInt_FromLong(v);
	}
}

static inline PyObject *ndr_PyLong_FromUnsignedLongLong(unsigned long long v)
{
	if (v > LONG_MAX) {
		return PyLong_FromUnsignedLongLong(v);
	} else {
		return PyInt_FromLong(v);
	}
}

static PyTypeObject smb2_lease_key_Type;
static PyTypeObject smb2_lease_Type;

static PyTypeObject *BaseObject_Type;

static PyObject *py_smb2_lease_key_get_data(PyObject *obj, void *closure)
{
	struct smb2_lease_key *object = (struct smb2_lease_key *)pytalloc_get_ptr(obj);
	PyObject *py_data;
	py_data = PyList_New(2);
	if (py_data == NULL) {
		return NULL;
	}
	{
		int data_cntr_0;
		for (data_cntr_0 = 0; data_cntr_0 < (2); data_cntr_0++) {
			PyObject *py_data_0;
			py_data_0 = ndr_PyLong_FromUnsignedLongLong(object->data[data_cntr_0]);
			PyList_SetItem(py_data, data_cntr_0, py_data_0);
		}
	}
	return py_data;
}

static int py_smb2_lease_key_set_data(PyObject *py_obj, PyObject *value, void *closure)
{
	struct smb2_lease_key *object = (struct smb2_lease_key *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->data");
		return -1;
	}
	PY_CHECK_TYPE(&PyList_Type, value, return -1;);
	{
		int data_cntr_0;
		if (ARRAY_SIZE(object->data) != PyList_GET_SIZE(value)) {
			PyErr_Format(PyExc_TypeError, "Expected list of type %s, length %zu, got %zd", Py_TYPE(value)->tp_name, ARRAY_SIZE(object->data),  PyList_GET_SIZE(value));
			return -1;
		}
		for (data_cntr_0 = 0; data_cntr_0 < PyList_GET_SIZE(value); data_cntr_0++) {
			if (PyList_GET_ITEM(value, data_cntr_0) == NULL) {
				PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->data[data_cntr_0]");
				return -1;
			}
			{
				const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->data[data_cntr_0]));
				if (PyLong_Check(PyList_GET_ITEM(value, data_cntr_0))) {
					unsigned long long test_var;
					test_var = PyLong_AsUnsignedLongLong(PyList_GET_ITEM(value, data_cntr_0));
					if (PyErr_Occurred() != NULL) {
						return -1;
					}
					if (test_var > uint_max) {
						PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
						  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
						return -1;
					}
					object->data[data_cntr_0] = test_var;
				} else if (PyInt_Check(PyList_GET_ITEM(value, data_cntr_0))) {
					long test_var;
					test_var = PyInt_AsLong(PyList_GET_ITEM(value, data_cntr_0));
					if (test_var < 0 || (unsigned long long)test_var > uint_max) {
						PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
						  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
						return -1;
					}
					object->data[data_cntr_0] = test_var;
				} else {
					PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
					  PyInt_Type.tp_name, PyLong_Type.tp_name);
					return -1;
				}
			}
		}
	}
	return 0;
}

static PyGetSetDef py_smb2_lease_key_getsetters[] = {
	{
		.name = discard_const_p(char, "data"),
		.get = py_smb2_lease_key_get_data,
		.set = py_smb2_lease_key_set_data,
		.doc = discard_const_p(char, "PIDL-generated element of base type hyper")
	},
	{ .name = NULL }
};

static PyObject *py_smb2_lease_key_new(PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
	return pytalloc_new(struct smb2_lease_key, type);
}

static PyObject *py_smb2_lease_key_ndr_pack(PyObject *py_obj)
{
	struct smb2_lease_key *object = (struct smb2_lease_key *)pytalloc_get_ptr(py_obj);
	PyObject *ret = NULL;
	DATA_BLOB blob;
	enum ndr_err_code err;
	TALLOC_CTX *tmp_ctx = talloc_new(pytalloc_get_mem_ctx(py_obj));
	if (tmp_ctx == NULL) {
		PyErr_SetNdrError(NDR_ERR_ALLOC);
		return NULL;
	}
	err = ndr_push_struct_blob(&blob, tmp_ctx, object, (ndr_push_flags_fn_t)ndr_push_smb2_lease_key);
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		TALLOC_FREE(tmp_ctx);
		PyErr_SetNdrError(err);
		return NULL;
	}

	ret = PyBytes_FromStringAndSize((char *)blob.data, blob.length);
	TALLOC_FREE(tmp_ctx);
	return ret;
}

static PyObject *py_smb2_lease_key_ndr_unpack(PyObject *py_obj, PyObject *args, PyObject *kwargs)
{
	struct smb2_lease_key *object = (struct smb2_lease_key *)pytalloc_get_ptr(py_obj);
	DATA_BLOB blob;
	Py_ssize_t blob_length = 0;
	enum ndr_err_code err;
	const char * const kwnames[] = { "data_blob", "allow_remaining", NULL };
	PyObject *allow_remaining_obj = NULL;
	bool allow_remaining = false;

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, PYARG_BYTES_LEN "|O:__ndr_unpack__",
		discard_const_p(char *, kwnames),
		&blob.data, &blob_length,
		&allow_remaining_obj)) {
		return NULL;
	}
	blob.length = blob_length;

	if (allow_remaining_obj && PyObject_IsTrue(allow_remaining_obj)) {
		allow_remaining = true;
	}

	if (allow_remaining) {
		err = ndr_pull_struct_blob(&blob, pytalloc_get_mem_ctx(py_obj), object, (ndr_pull_flags_fn_t)ndr_pull_smb2_lease_key);
	} else {
		err = ndr_pull_struct_blob_all(&blob, pytalloc_get_mem_ctx(py_obj), object, (ndr_pull_flags_fn_t)ndr_pull_smb2_lease_key);
	}
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		PyErr_SetNdrError(err);
		return NULL;
	}

	Py_RETURN_NONE;
}

static PyObject *py_smb2_lease_key_ndr_print(PyObject *py_obj)
{
	struct smb2_lease_key *object = (struct smb2_lease_key *)pytalloc_get_ptr(py_obj);
	PyObject *ret;
	char *retstr;

	retstr = ndr_print_struct_string(pytalloc_get_mem_ctx(py_obj), (ndr_print_fn_t)ndr_print_smb2_lease_key, "smb2_lease_key", object);
	ret = PyStr_FromString(retstr);
	talloc_free(retstr);

	return ret;
}

static PyMethodDef py_smb2_lease_key_methods[] = {
	{ "__ndr_pack__", (PyCFunction)py_smb2_lease_key_ndr_pack, METH_NOARGS, "S.ndr_pack(object) -> blob\nNDR pack" },
	{ "__ndr_unpack__", (PyCFunction)py_smb2_lease_key_ndr_unpack, METH_VARARGS|METH_KEYWORDS, "S.ndr_unpack(class, blob, allow_remaining=False) -> None\nNDR unpack" },
	{ "__ndr_print__", (PyCFunction)py_smb2_lease_key_ndr_print, METH_NOARGS, "S.ndr_print(object) -> None\nNDR print" },
	{ NULL, NULL, 0, NULL }
};


static PyTypeObject smb2_lease_key_Type = {
	PyVarObject_HEAD_INIT(NULL, 0)
	.tp_name = "smb2_lease_struct.smb2_lease_key",
	.tp_getset = py_smb2_lease_key_getsetters,
	.tp_methods = py_smb2_lease_key_methods,
	.tp_flags = Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,
	.tp_new = py_smb2_lease_key_new,
};


static PyObject *py_smb2_lease_get_lease_key(PyObject *obj, void *closure)
{
	struct smb2_lease *object = (struct smb2_lease *)pytalloc_get_ptr(obj);
	PyObject *py_lease_key;
	py_lease_key = pytalloc_reference_ex(&smb2_lease_key_Type, pytalloc_get_mem_ctx(obj), &object->lease_key);
	return py_lease_key;
}

static int py_smb2_lease_set_lease_key(PyObject *py_obj, PyObject *value, void *closure)
{
	struct smb2_lease *object = (struct smb2_lease *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->lease_key");
		return -1;
	}
	PY_CHECK_TYPE(&smb2_lease_key_Type, value, return -1;);
	if (talloc_reference(pytalloc_get_mem_ctx(py_obj), pytalloc_get_mem_ctx(value)) == NULL) {
		PyErr_NoMemory();
		return -1;
	}
	object->lease_key = *(struct smb2_lease_key *)pytalloc_get_ptr(value);
	return 0;
}

static PyObject *py_smb2_lease_get_lease_state(PyObject *obj, void *closure)
{
	struct smb2_lease *object = (struct smb2_lease *)pytalloc_get_ptr(obj);
	PyObject *py_lease_state;
	py_lease_state = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->lease_state);
	return py_lease_state;
}

static int py_smb2_lease_set_lease_state(PyObject *py_obj, PyObject *value, void *closure)
{
	struct smb2_lease *object = (struct smb2_lease *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->lease_state");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->lease_state));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->lease_state = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->lease_state = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_smb2_lease_get_lease_flags(PyObject *obj, void *closure)
{
	struct smb2_lease *object = (struct smb2_lease *)pytalloc_get_ptr(obj);
	PyObject *py_lease_flags;
	py_lease_flags = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->lease_flags);
	return py_lease_flags;
}

static int py_smb2_lease_set_lease_flags(PyObject *py_obj, PyObject *value, void *closure)
{
	struct smb2_lease *object = (struct smb2_lease *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->lease_flags");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->lease_flags));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->lease_flags = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->lease_flags = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_smb2_lease_get_lease_duration(PyObject *obj, void *closure)
{
	struct smb2_lease *object = (struct smb2_lease *)pytalloc_get_ptr(obj);
	PyObject *py_lease_duration;
	py_lease_duration = ndr_PyLong_FromUnsignedLongLong(object->lease_duration);
	return py_lease_duration;
}

static int py_smb2_lease_set_lease_duration(PyObject *py_obj, PyObject *value, void *closure)
{
	struct smb2_lease *object = (struct smb2_lease *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->lease_duration");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->lease_duration));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->lease_duration = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->lease_duration = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_smb2_lease_get_parent_lease_key(PyObject *obj, void *closure)
{
	struct smb2_lease *object = (struct smb2_lease *)pytalloc_get_ptr(obj);
	PyObject *py_parent_lease_key;
	py_parent_lease_key = pytalloc_reference_ex(&smb2_lease_key_Type, pytalloc_get_mem_ctx(obj), &object->parent_lease_key);
	return py_parent_lease_key;
}

static int py_smb2_lease_set_parent_lease_key(PyObject *py_obj, PyObject *value, void *closure)
{
	struct smb2_lease *object = (struct smb2_lease *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->parent_lease_key");
		return -1;
	}
	PY_CHECK_TYPE(&smb2_lease_key_Type, value, return -1;);
	if (talloc_reference(pytalloc_get_mem_ctx(py_obj), pytalloc_get_mem_ctx(value)) == NULL) {
		PyErr_NoMemory();
		return -1;
	}
	object->parent_lease_key = *(struct smb2_lease_key *)pytalloc_get_ptr(value);
	return 0;
}

static PyObject *py_smb2_lease_get_lease_version(PyObject *obj, void *closure)
{
	struct smb2_lease *object = (struct smb2_lease *)pytalloc_get_ptr(obj);
	PyObject *py_lease_version;
	py_lease_version = PyInt_FromLong((uint16_t)object->lease_version);
	return py_lease_version;
}

static int py_smb2_lease_set_lease_version(PyObject *py_obj, PyObject *value, void *closure)
{
	struct smb2_lease *object = (struct smb2_lease *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->lease_version");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->lease_version));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->lease_version = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->lease_version = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_smb2_lease_get_lease_epoch(PyObject *obj, void *closure)
{
	struct smb2_lease *object = (struct smb2_lease *)pytalloc_get_ptr(obj);
	PyObject *py_lease_epoch;
	py_lease_epoch = PyInt_FromLong((uint16_t)object->lease_epoch);
	return py_lease_epoch;
}

static int py_smb2_lease_set_lease_epoch(PyObject *py_obj, PyObject *value, void *closure)
{
	struct smb2_lease *object = (struct smb2_lease *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->lease_epoch");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->lease_epoch));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->lease_epoch = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->lease_epoch = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyGetSetDef py_smb2_lease_getsetters[] = {
	{
		.name = discard_const_p(char, "lease_key"),
		.get = py_smb2_lease_get_lease_key,
		.set = py_smb2_lease_set_lease_key,
		.doc = discard_const_p(char, "PIDL-generated element of base type smb2_lease_key")
	},
	{
		.name = discard_const_p(char, "lease_state"),
		.get = py_smb2_lease_get_lease_state,
		.set = py_smb2_lease_set_lease_state,
		.doc = discard_const_p(char, "PIDL-generated element of base type smb2_lease_state")
	},
	{
		.name = discard_const_p(char, "lease_flags"),
		.get = py_smb2_lease_get_lease_flags,
		.set = py_smb2_lease_set_lease_flags,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint32")
	},
	{
		.name = discard_const_p(char, "lease_duration"),
		.get = py_smb2_lease_get_lease_duration,
		.set = py_smb2_lease_set_lease_duration,
		.doc = discard_const_p(char, "PIDL-generated element of base type hyper")
	},
	{
		.name = discard_const_p(char, "parent_lease_key"),
		.get = py_smb2_lease_get_parent_lease_key,
		.set = py_smb2_lease_set_parent_lease_key,
		.doc = discard_const_p(char, "PIDL-generated element of base type smb2_lease_key")
	},
	{
		.name = discard_const_p(char, "lease_version"),
		.get = py_smb2_lease_get_lease_version,
		.set = py_smb2_lease_set_lease_version,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint16")
	},
	{
		.name = discard_const_p(char, "lease_epoch"),
		.get = py_smb2_lease_get_lease_epoch,
		.set = py_smb2_lease_set_lease_epoch,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint16")
	},
	{ .name = NULL }
};

static PyObject *py_smb2_lease_new(PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
	return pytalloc_new(struct smb2_lease, type);
}

static PyObject *py_smb2_lease_ndr_pack(PyObject *py_obj)
{
	struct smb2_lease *object = (struct smb2_lease *)pytalloc_get_ptr(py_obj);
	PyObject *ret = NULL;
	DATA_BLOB blob;
	enum ndr_err_code err;
	TALLOC_CTX *tmp_ctx = talloc_new(pytalloc_get_mem_ctx(py_obj));
	if (tmp_ctx == NULL) {
		PyErr_SetNdrError(NDR_ERR_ALLOC);
		return NULL;
	}
	err = ndr_push_struct_blob(&blob, tmp_ctx, object, (ndr_push_flags_fn_t)ndr_push_smb2_lease);
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		TALLOC_FREE(tmp_ctx);
		PyErr_SetNdrError(err);
		return NULL;
	}

	ret = PyBytes_FromStringAndSize((char *)blob.data, blob.length);
	TALLOC_FREE(tmp_ctx);
	return ret;
}

static PyObject *py_smb2_lease_ndr_unpack(PyObject *py_obj, PyObject *args, PyObject *kwargs)
{
	struct smb2_lease *object = (struct smb2_lease *)pytalloc_get_ptr(py_obj);
	DATA_BLOB blob;
	Py_ssize_t blob_length = 0;
	enum ndr_err_code err;
	const char * const kwnames[] = { "data_blob", "allow_remaining", NULL };
	PyObject *allow_remaining_obj = NULL;
	bool allow_remaining = false;

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, PYARG_BYTES_LEN "|O:__ndr_unpack__",
		discard_const_p(char *, kwnames),
		&blob.data, &blob_length,
		&allow_remaining_obj)) {
		return NULL;
	}
	blob.length = blob_length;

	if (allow_remaining_obj && PyObject_IsTrue(allow_remaining_obj)) {
		allow_remaining = true;
	}

	if (allow_remaining) {
		err = ndr_pull_struct_blob(&blob, pytalloc_get_mem_ctx(py_obj), object, (ndr_pull_flags_fn_t)ndr_pull_smb2_lease);
	} else {
		err = ndr_pull_struct_blob_all(&blob, pytalloc_get_mem_ctx(py_obj), object, (ndr_pull_flags_fn_t)ndr_pull_smb2_lease);
	}
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		PyErr_SetNdrError(err);
		return NULL;
	}

	Py_RETURN_NONE;
}

static PyObject *py_smb2_lease_ndr_print(PyObject *py_obj)
{
	struct smb2_lease *object = (struct smb2_lease *)pytalloc_get_ptr(py_obj);
	PyObject *ret;
	char *retstr;

	retstr = ndr_print_struct_string(pytalloc_get_mem_ctx(py_obj), (ndr_print_fn_t)ndr_print_smb2_lease, "smb2_lease", object);
	ret = PyStr_FromString(retstr);
	talloc_free(retstr);

	return ret;
}

static PyMethodDef py_smb2_lease_methods[] = {
	{ "__ndr_pack__", (PyCFunction)py_smb2_lease_ndr_pack, METH_NOARGS, "S.ndr_pack(object) -> blob\nNDR pack" },
	{ "__ndr_unpack__", (PyCFunction)py_smb2_lease_ndr_unpack, METH_VARARGS|METH_KEYWORDS, "S.ndr_unpack(class, blob, allow_remaining=False) -> None\nNDR unpack" },
	{ "__ndr_print__", (PyCFunction)py_smb2_lease_ndr_print, METH_NOARGS, "S.ndr_print(object) -> None\nNDR print" },
	{ NULL, NULL, 0, NULL }
};


static PyTypeObject smb2_lease_Type = {
	PyVarObject_HEAD_INIT(NULL, 0)
	.tp_name = "smb2_lease_struct.smb2_lease",
	.tp_getset = py_smb2_lease_getsetters,
	.tp_methods = py_smb2_lease_methods,
	.tp_flags = Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,
	.tp_new = py_smb2_lease_new,
};

static PyMethodDef smb2_lease_struct_methods[] = {
	{ NULL, NULL, 0, NULL }
};

static struct PyModuleDef moduledef = {
	PyModuleDef_HEAD_INIT,
	.m_name = "smb2_lease_struct",
	.m_doc = "smb2_lease_struct DCE/RPC",
	.m_size = -1,
	.m_methods = smb2_lease_struct_methods,
};
MODULE_INIT_FUNC(smb2_lease_struct)
{
	PyObject *m;
	PyObject *dep_talloc;

	dep_talloc = PyImport_ImportModule("talloc");
	if (dep_talloc == NULL)
		return NULL;

	BaseObject_Type = (PyTypeObject *)PyObject_GetAttrString(dep_talloc, "BaseObject");
	if (BaseObject_Type == NULL)
		return NULL;

	smb2_lease_key_Type.tp_base = BaseObject_Type;
	smb2_lease_key_Type.tp_basicsize = pytalloc_BaseObject_size();

	smb2_lease_Type.tp_base = BaseObject_Type;
	smb2_lease_Type.tp_basicsize = pytalloc_BaseObject_size();

	if (PyType_Ready(&smb2_lease_key_Type) < 0)
		return NULL;
	if (PyType_Ready(&smb2_lease_Type) < 0)
		return NULL;
#ifdef PY_SMB2_LEASE_KEY_PATCH
	PY_SMB2_LEASE_KEY_PATCH(&smb2_lease_key_Type);
#endif
#ifdef PY_SMB2_LEASE_PATCH
	PY_SMB2_LEASE_PATCH(&smb2_lease_Type);
#endif

	m = PyModule_Create(&moduledef);
	if (m == NULL)
		return NULL;

	PyModule_AddObject(m, "SMB2_LEASE_READ", ndr_PyLong_FromUnsignedLongLong((uint32_t)SMB2_LEASE_READ));
	PyModule_AddObject(m, "SMB2_LEASE_HANDLE", ndr_PyLong_FromUnsignedLongLong((uint32_t)SMB2_LEASE_HANDLE));
	PyModule_AddObject(m, "SMB2_LEASE_WRITE", ndr_PyLong_FromUnsignedLongLong((uint32_t)SMB2_LEASE_WRITE));
	Py_INCREF((PyObject *)(void *)&smb2_lease_key_Type);
	PyModule_AddObject(m, "smb2_lease_key", (PyObject *)(void *)&smb2_lease_key_Type);
	Py_INCREF((PyObject *)(void *)&smb2_lease_Type);
	PyModule_AddObject(m, "smb2_lease", (PyObject *)(void *)&smb2_lease_Type);
#ifdef PY_MOD_SMB2_LEASE_STRUCT_PATCH
	PY_MOD_SMB2_LEASE_STRUCT_PATCH(m);
#endif
	return m;

}
